{=========================================================================}
program EDIBYTE;

uses crt;

label CIF,SIM;

type
    BINF=file of char;

const
     SPC19='                   ';
     SPC60='                                                            ';

var
   FN,C,T,TMP :integer;
   A,B,L,S,M,F,TP,RQ,SP,EX,DIFI,I,J,AZ,PER :longint;
   STROBU :array[1..4] of char;
   RRSF :single absolute STROBU;
   RRSI :integer absolute STROBU;
   SST,IMIS,PS :string;
   REDFIL :BINF;
   KODS :array[0..16,0..15] of char;
   PRIZ :array[0..16,0..15] of boolean;
   TMPB,KEY,KOD,Z :byte;

{ KODS - ᨢ 祭 ⮢ ࠭
  PRIZ - ਧ  
  STROBU -  ᨢ  ⥭   ᥫ
  RRSF - ⢨⥫쭮 ᫮  ⥭  
  RRSI - 楫 ᫮  ⥭  
  F - ਧ ᥭ 
  L - ⥪ ப
  S - ⥪騩 ⮫
  SP - ࠢ ५뢠
  RQ - ⥪騩 ᥣ
  TP - ⥪ ࠭
  DIFI -  䠩
  IMIS -  ।㥬 䠩}

{=========================================================================}
procedure INICIAL;
begin
     L:=0;S:=0;M:=0;F:=0;TP:=0;RQ:=0;SP:=0;
     textcolor(0);textbackground(7);clrscr;textcolor(6);gotoxy(1,2);
     write('Ŀ');
     for TMP:=1 to 16 do
     write('HEX:                                                                        ');
     write('Ĵ');
     write(' current                                                                     ');
     write(' addr:                                                                       ');
     write(' code:                                                                       ');
     write('');
     textcolor(1);textbackground(3);gotoxy(1,25);
     write('F2-save  F3-switch  F4-address  F5-integer  F6-real  F7-input  F9-new  F10-exit');
end;
{-------------------------------------------------------------------------}
procedure SAVING;
begin
     F:=0;A:=RQ*65536+TP*256;
     for I:=0 to 16 do
     for J:=0 to 15 do begin
         seek(REDFIL,A+I*16+J);
         if PRIZ[I,J] then write(REDFIL,KODS[I,J]);
     end;
end;
{-------------------------------------------------------------------------}
procedure CLEAR;
begin
     textcolor(5);textbackground(7);
     for TMP:=20 to 22 do begin gotoxy(20,TMP);write(SPC60); end;
end;
{-------------------------------------------------------------------------}
procedure ADRES;
begin
     B:=RQ*65536+TP*256+L*16+S;
     textcolor(0);textbackground(7);gotoxy(9,21);
     write('          ');gotoxy(9,21);write(B);
     EX:=0;if PRIZ[L,S] then A:=ord(KODS[L,S]) else begin A:=0;EX:=1; end;
     gotoxy(9,22);write('          ');gotoxy(9,22);
     if EX<>0 then write('EOF') else write(A);
end;
{-------------------------------------------------------------------------}
procedure QUTPRO;
begin
     if F<>0 then begin
        textcolor(4);textbackground(7);gotoxy(3,24);
        write('Save changes? (y/n/E):');
        TMPB:=0;
        while TMPB=0 do begin
              TMPB:=ord(readkey);
              if TMPB=0 then begin TMPB:=ord(readkey);TMPB:=0; end;
        end;
        gotoxy(1,24);write(SPC60);
        if (TMPB=89) or (TMPB=121) then SAVING
        else if (TMPB=78) or (TMPB=110) then F:=0;
     end;
end;
{-------------------------------------------------------------------------}
function HEXX(var FN:integer):string;
begin
     if FN<10 then HEXX:=chr(FN+48) else HEXX:=chr(FN+55);
end;
{-------------------------------------------------------------------------}
function HEX(N:longint):string;
var I,J :longint;
begin
     SST:='';T:=0;J:=16777216;
     for I:=1 to 6 do begin
         FN:=N div J;N:=N mod J;J:=J div 16;
         SST:=SST+HEXX(FN);if (FN>0) and (T=0) then T:=I;
     end;
     FN:=N;SST:=SST+HEXX(FN);if T=0 then T:=7;
     HEX:=copy(SST,T,8-T);
end;
{-------------------------------------------------------------------------}
procedure EKRAN;
begin
     A:=RQ*65536+TP*256;
     for I:=0 to 15 do begin
         textcolor(6);textbackground(7);gotoxy(1,I+3);write('');
         for J:=0 to 15 do begin
             C:=0;if PRIZ[I,J] then C:=ord(KODS[I,J]);
             PS:=HEX(C);if length(PS)=1 then PS:='0'+PS;
             textcolor(0);textbackground(7);gotoxy(J*3+15,I+3);write(PS);
             gotoxy(J+64,I+3);
             if PRIZ[I,J] then begin
                KOD:=ord(KODS[I,J]);
                if (KOD>6) and (KOD<14) then begin
                   textbackground(3);write(chr(KOD+64));
                end else write(KODS[I,J]);
             end else begin
                textcolor(5);write('');
             end;
         end;
         SST:=HEX((A div 16)+I);
         for TMP:=1 to 5 do if length(SST)<6 then SST:='0'+SST;
         textcolor(0);textbackground(7);gotoxy(6,I+3);write(SST,'0');
     end;
     ADRES;
end;
{-------------------------------------------------------------------------}
procedure GROIS;
begin
     QUTPRO;if F<>0 then exit;
     TP:=TP+SP;SP:=0;
     if TP>255 then begin TP:=0;RQ:=RQ+1; end;
     if TP<0 then begin TP:=255;RQ:=RQ-1; end;
     if RQ<0 then begin RQ:=0;TP:=0; end;
     A:=RQ*65536+TP*256;
     for I:=0 to 16 do
     for J:=0 to 15 do begin
         seek(REDFIL,A+I*16+J);PRIZ[I,J]:=false;
         if not eof(REDFIL) then begin
            read(REDFIL,KODS[I,J]);PRIZ[I,J]:=true;
         end;
     end;
     for I:=0 to 15 do begin
     end;
     EKRAN;
end;
{-------------------------------------------------------------------------}
procedure PEREX;
begin
     CLEAR;gotoxy(45,20);write('GO TO ADDRESS');
     gotoxy(21,21);write('address: ');read(PER);CLEAR;
     if PER>DIFI then exit;
     QUTPRO;if F<>0 then exit;
     RQ:=PER div 65536;TP:=(PER-RQ*65536) div 256;
     TMP:=(PER-RQ*65536) mod 256;L:=TMP div 16;S:=TMP mod 16;M:=S*3;
     GROIS;
end;
{-------------------------------------------------------------------------}
procedure READAT;
begin
     CLEAR;gotoxy(40,20);I:=L;J:=S;EX:=(Z-62)*2;
     for TMP:=1 to EX do begin
         STROBU[TMP]:=KODS[I,J];J:=J+1;
         if J>15 then begin J:=0;I:=I+1; end;
     end;
     if EX=2 then write(RRSI) else write(RRSF);
end;
{-------------------------------------------------------------------------}
procedure CISLO;
begin
     CLEAR;gotoxy(45,20);write('INPUT NUMBER');
     gotoxy(21,21);write('type (I/R):');KOD:=ord(upcase(readkey));
     gotoxy(21,22);write('number: ');EX:=abs((KOD-64)*2 div 9);
     if EX=2 then read(RRSI)
     else if EX=4 then read(RRSF)
     else begin CLEAR;exit;
     end;
     seek(REDFIL,B);I:=L;J:=S;
     for TMP:=1 to EX do begin
         KODS[I,J]:=STROBU[TMP];J:=J+1;
         if J>15 then begin J:=0;I:=I+1; end;
     end;
     F:=1;CLEAR;EKRAN;
end;
{-------------------------------------------------------------------------}
procedure VYXOD;
begin
     QUTPRO;if F<>0 then exit;
     close(REDFIL);textcolor(7);textbackground(0);clrscr;
     halt(0);
end;
{-------------------------------------------------------------------------}
procedure NOVFILE;
begin
     QUTPRO;SST:='';if F<>0 then exit;
     CLEAR;gotoxy(46,20);write('NEW FILE');
     gotoxy(21,21);write('name: ');readln(SST);CLEAR;
     if SST<>'' then begin close(REDFIL);IMIS:=SST; end;
end;
{-------------------------------------------------------------------------}
procedure OPENFILE;
begin
     assign(REDFIL,IMIS);reset(REDFIL);DIFI:=filesize(REDFIL);
     textcolor(1);textbackground(7);gotoxy(1,1);write(SPC60,SPC19);
     gotoxy(1,1);write(' File `',IMIS,'`;  Length:',DIFI);
     GROIS;
end;
{-------------------------------------------------------------------------}
procedure ANALIS;
begin
     case Z of
            60:SAVING;
            71:begin S:=0;M:=0; end;
            79:begin S:=15;M:=45; end;
            72:L:=L-1;
            80:L:=L+1;
            73:begin SP:=-1;GROIS; end;
            81:begin SP:=1;GROIS; end;
            62:PEREX;
            65:CISLO;
            63,64:READAT;
            67:begin NOVFILE;if SST<>'' then OPENFILE; end;
            68:VYXOD;
     end;
end;
{=========================================================================}
begin

     FN:=paramcount;
     if FN<>1 then begin
        writeln(' `EDIBYTE` - minieditor for (existing) binary files.');
        writeln(' (E.H.Hauser, Baku, 26/11/95, 03:00:00, size 29376).');
        writeln(' usage: edibyte1.exe <filename.ext>');
        writeln(' Use program `BINED` for more!');
        writeln;halt(0);
     end;
     IMIS:=paramstr(1);INICIAL;OPENFILE;
     goto CIF;

CIF:
     textcolor(0);textbackground(7);gotoxy(M+15,L+3);
     KOD:=ord(readkey);KEY:=1;
     if KOD=0 then begin KOD:=ord(readkey);KEY:=2; end;
     Z:=KOD;
     if KEY=1 then begin
        T:=-1;
        if (47<Z) and (Z<58) then T:=Z-48;
        if (64<Z) and (Z<71) then T:=Z-55;
        if (96<Z) and (Z<103) then T:=Z-87;
        if T<0 then begin sound(500);delay(1000);nosound;goto CIF; end;
        if ((M+1) mod 3)<>0 then begin
           F:=1;C:=0;if PRIZ[L,S] then C:=ord(KODS[L,S]);
           write(upcase(chr(KOD)));
           if (M mod 3)=0 then begin
              C:=T*16+(C mod 16);AZ:=1;
           end else begin
              C:=(C div 16)*16+T;AZ:=2;
           end;
           KODS[L,S]:=chr(C);PRIZ[L,S]:=true;gotoxy(S+64,L+3);M:=M+AZ;
           if (C>6) and (C<14) then begin
              textbackground(3);write(chr(KOD+64));
           end else write(KODS[L,S]);
        end
     end else begin
        case Z of
                61:goto SIM;
                75:M:=M-1;
                77:M:=M+1;
                else ANALIS
        end;
     end;
     if M<0 then begin M:=46;L:=L-1; end;
     if M>46 then begin M:=0;L:=L+1; end;
     if L<0 then L:=15 else if L>15 then L:=0;
     S:=M div 3; ADRES;
     goto CIF;

SIM:
     textcolor(0);textbackground(7);gotoxy(S+64,L+3);
     KOD:=ord(readkey);M:=S*3;KEY:=1;
     if KOD=0 then begin KOD:=ord(readkey);KEY:=2; end;
     Z:=KOD;
     if KEY=1 then begin
        F:=1;SST:=HEX(Z);if length(SST)=1 then SST:='0'+SST;
        gotoxy(M+15,L+3);write(SST);
        KODS[L,S]:=chr(Z);PRIZ[L,S]:=true;gotoxy(S+64,L+3);
        if (Z>6) and (Z<14) then begin
           textbackground(3);write(chr(Z+64));
        end else write(KODS[L,S]);
        S:=S+1;
     end else begin
        case Z of
                61:goto CIF;
                75:S:=S-1;
                77:S:=S+1;
                else ANALIS
        end;
     end;
     if S<0 then begin S:=15;L:=L-1; end;
     if S>15 then begin S:=0;L:=L+1; end;
     if L<0 then L:=15 else if L>15 then L:=0;
     M:=S*3;ADRES;
     goto SIM;

end.
{=========================================================================}
